// 
//
#ifndef SERVER_IS_IN
#define SERVER_IS_IN

#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#define BUFFER_SIZE 8192
#define NOTOK (-1)
#define OK 0

class Server {
 private:
   static unsigned long current;
   static char *currName;
   static int currPort;
   int sock;
   struct sockaddr_in server;
   char buffer[BUFFER_SIZE];
   int pos, pos_max;

 public:
   Server( char const *host, int port );
   ~Server();

   int Close( void );
   int Open( void );

   int Connect( int allow_EINTR = 0 );
   int Bind( void );
   int Listen( int n = 5 );

   int SetPort( int port );
   int SetServer( char const *name );
   static void SetCurrentServer( char const *name );
   static char const *CurrentServer( void ) { return currName; }
   static int IsCurrent( char const *name, int port );
   static void SetCurrentPort( int port ) { currPort = port; }
   static int CurrentPort( void ) { return currPort; }

   char	*ReadLine( char *buffer, int maxlength, char *terminator = "\n" );
   int ReadChar( void );
   int WriteLine( char *buffer, char *eol = "\n" );

   int Write( char *buffer, int maxlength = -1 );
   int Read( char *buffer, int maxlength );

   int ReadPartial(char *buffer, int maxlength);
   int WritePartial(char *buffer, int maxlength);

};

unsigned long gethostip(char *ip = 0, int length = 0);

#endif
